/*//////////////////////////////////////////////////////////////*\
**||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||**|
**---------------------------------------------------------------/
** Zenerd Standard Library
**  Copyright (C) 2000-2002 by Zenerd
**
** Component: Time Line Data-Structure
**
** Date     : October 2001
**
** Author(s): Jeffrey M. Barber
**          :
**          :
**          :
**          :
**          :
**
** Notes    : 
** 
** 
** Revisions:
** (MM\YYYY):
**
**
**
**---------------------------------------------------------------\
**||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||||**|
**\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\*/
#ifndef ZENERD_TIMELINE
#define ZENERD_TIMELINE

#include <vector>

using namespace std;
class ZTimeSpan;

class ZTimeLine
{
	private:
		vector<ZTimeSpan> m_ZTimeSpans;
		int MaxTime;

		void swap(int a, int b);
		void qsort(int l = -100, int r = -100);

	public:
		ZTimeLine();
		ZTimeLine(const ZTimeLine & c);
		~ZTimeLine();
		operator=(const ZTimeLine & c);
		
		bool AddTimeSpan(int Owner, int Action);
		int  GetTimeSpan(int Owner, int Action);
		bool AddTimeSlice(int Span, int Time, int Length, double Weight);
		int  GetTimeSlice(int Span, int Time);
		
		int GetSpanCount();
		int GetSliceCount(int Span);
		void GetSlice(int Span, int Slice, int & Start, int & Length, double & Weight);
		int  GetSlice(int Span, int Time);
		void Edit(int Span, int Slice, int Start, int Length, double Weight);
		void Delete(int Span, int Slice = -1);

		void SetAction(int Span, int Action);
		int GetAction(int Span);

		void SetOwner(int Span, int Owner);
		int GetOwner(int Span);
		bool isCollision(int Span, int Skip, int Start, int Length);// is there a collision between this data and other data

		
};

#endif